<template>
  <div class="w-full flex justify-center items-center  py-2 mb-4 mobile-promo-title" style="background-color: var(--background1);">
    <h3 class="text-base font-normal" style="color: var(--text);">{{ $t('promotion') }}</h3>
  </div>
  <header class="text-center tab_background_tab mb-6 desktop-promo-filter">
    <div class="tab flex h-[56px] items-center">
      <div
        v-for="(tab, index) in Object.entries(initPromotions)"
        :key="tab[0]"
        :class="{ active: tab[1].IsActive }"
        @click="onTabClick(tab[0])"
      >
        {{ $t(tab[1].Name) }}
        <el-divider
          v-if="Object.entries(initPromotions).length - 1 !== index"
          direction="vertical"
          class="divider-[#D3DEC4]"
        />
      </div>
    </div>
  </header>
  <div
    v-if="promotions.length === 0"
    class="flex flex-col justify-center items-center my-[60px] col-span-3 overflow-hidden" >
    <div class="text-4xl text-center truncate text-ellipsis">
      {{ $t("no_promotion_info") }}
    </div>
    <span class="font-bold text-lg fc-text">{{ assignHashText }}</span>
  </div>
  <template v-else>
    <div    
    v-if="selectedPromotions[0] && selectedPromotions[0].Promotions.length < 1"
    class="flex flex-col justify-center items-center my-[60px] col-span-3 overflow-hidden" >
      <div class="text-4xl text-center truncate text-ellipsis">
        {{ $t("no_promotion_info") }}
      </div>
    </div>
    <div class="peru-promotion-container">
      <article v-for="promotion in selectedPromotions[0].Promotions" class="peru-promo-card" >
        <div class="peru-promo-card__img">
          <img v-lazy="promotion.ImagePathForDisplay" class="w-full h-full object-center object-contain" />
        </div>
        <div class="peru-promo-card__content p-4 bg-black/10">
          <div class="peru-promo-card__text">
            <h5 class="peru-promo-card__title font-bold text-sm mb-1">{{ promotion.Title }}</h5> 
            <p class="peru-promo-card__subtitle duration mb-1" style="color: var(--text)"><span class="peru-promo-card__label">{{ $t('duration') }} : </span><span class="peru-promo-card__duration" style="color: var(--primary)">{{ promotion.DateRangeForDisplay }}</span></p>
            <p class="peru-promo-card__subtitle code mb-2" style="color: var(--text)"><span class="peru-promo-card__label">{{ $t('code') }} : </span><span class="peru-promo-card__code">{{ promotion.PromoCode }}</span></p>
          </div>
          <div class="flex gap-2">
            <button class="peru-promo-card__btn plain" @click="onMoreInformation(promotion)" 
                   :id="`${ID.PROMOTION_INFO}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`">
                     <span class="pointer-events-none"> {{ $t('more_info') }}</span></button>
            <template v-if="promotion.PromotionTypeId === 10">
              <button class="peru-promo-card__btn bg-primary apply-btn" 
                v-if="validateLuckyWheelbutton(promotion)"
                @click="onClickSpinNow"
                :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
              >
                <div class="flex items-center gap-2 text-container pointer-events-none">
                  <span>{{ $t('Spin Now') }}</span>
                </div>
              </button>
            </template>
            <template v-else>
              <button class="peru-promo-card__btn bg-primary apply-btn" 
                v-if="buttonApplyPromotionEnabled(promotion)"
                @click="onApplyPromotion(promotion)"
                :disabled="isProcessing"
                :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
              >
                <div class="flex items-center gap-2 text-container pointer-events-none">
                  <el-icon class="is-loading" v-if="isProcessing && applyRequest.PromotionId === promotion.Id && !isDialogVisible">
                      <Loading />
                  </el-icon>
                  <span>{{ $t('apply')?.toLocaleLowerCase() }}</span>
                </div>
              </button>
            </template>
          </div>
        </div>
      </article>
    </div>
  </template>
  <el-dialog
    :show-close="false"
    v-model="isDialogVisible"
    destroy-on-close
    width="90%"
    :before-close="onClose"
    class="peru-promotion-dialog"
  >
    <template #title>
      <div class="peru-promotion-dialog__header">
        <span class="h-4 text-sm font-bold leading-4 fc-text peru-promotion-dialog__title">
          {{ promotionModel?.Title }}
        </span>
        <div class="peru-promotion-dialog__btn-container">
          <button class="peru-promotion-dialog__close-btn" @click="isDialogVisible = false;">
            <span class="close-btn-text">X</span>
            <img
              class="w-full h-full close-btn green-peru-filter"
              :src="getAssetImage('assets/theme/new_black_theme/close-icon.png')"
              alt=""
            />
          </button>
        </div>
      </div>
    </template>
    <div class="peru-promotion-dialog__body flex flex-col items-center justify-center" v-if="promotionModel">
      <div class="peru-promotion-dialog__info-container">
        <div class="peru-promo-card__img h-[146px] w-full">
          <img v-lazy="promotionModel.ImagePathForDisplay" class="w-full h-full object-center object-contain" />
        </div>
        <div class="peru-promotion-dialog__info flex flex-col gap-2">
            <p class="font-bold text-base text-[var(--primary)]">{{ promotionModel.DateRangeForDisplay }}</p>
            <p class="font-bold text-xl text-[var(--text4\_w)]">{{ promotionModel.Title }}</p>
            <p class="text-sm text-[var(--text4\_w)]">{{ promotionModel.PromoCode }}</p>
        </div>
      </div>
      <div class="peru-promotion-dialog__content">
        <div class="peru-promotion-dialog__info">
          <p class="peru-promo-card__subtitle text-xs mb-1" style="color: var(--text)">{{ $t('duration') }} : <span style="color: var(--primary)">{{ promotionModel.DateRangeForDisplay }}</span></p>
          <p class="peru-promo-card__subtitle text-xs" style="color: var(--text)">{{ $t('code') }} : <span style="color: var(--text2)">{{ promotionModel.PromoCode }}</span></p>
        </div>
        <el-scrollbar class="peru-promotion-dialog__description-container" v-if="promotionModel.Content" always>
          <div class="peru-promotion-dialog__description" v-html="promotionModel.Content" />
        </el-scrollbar>
        <div class="mt-2 peru-promotion-dialog__action-container">
          <button class="peru-promo-card__btn plain close-btn" @click="onClose"><span>{{ $t('close') }}</span></button>
          <template v-if="promotionModel.PromotionTypeId === 10">
            <button class="peru-promo-card__btn bg-primary apply-btn" 
              v-if="validateLuckyWheelbutton(promotionModel)"
              @click="onClickSpinNow"
              :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotionModel.PromotionTypeId]}_${promotionModel.Id}`"
            >
              <div class="flex items-center gap-2 text-container pointer-events-none">
                <span>{{ $t('Spin Now') }}</span>
              </div>
            </button>
          </template>
          <template v-else>
            <button 
              class="peru-promo-card__btn bg-primary"
              style="background-color: var(--primary); color: var(--textBtn);"
              v-if="buttonApplyPromotionEnabled(promotionModel)" @click="onApplyPromotion(promotionModel)"
              :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotionModel.PromotionTypeId]}_${promotionModel.Id}`"
              >
              <div class="flex items-center gap-2 pointer-events-none">
                    <el-icon class="is-loading" v-if="isProcessing && applyRequest.PromotionId === promotionModel.Id">
                        <Loading />
                    </el-icon>
                    <span>{{ $t('apply')?.toLocaleLowerCase() }}</span>
                  </div>
            </button>
          </template>
        </div>
      </div>
    </div>
  </el-dialog>
</template>

<script lang="ts">
import PromotionCard from "@/components/theme/desktop/peru/components/promotion/vertical-card.client.vue";
import { Loading } from "@element-plus/icons-vue";
import { ElIcon } from "element-plus";
import { defineComponent } from "vue";
import { IPromotion, Promotion } from "~~/models/promotion/promotion";
import { ID } from "~~/utils/constants";
interface IPromotionLFM1 {
  Name: string;
  SearchKey: string;
  AvoidKey: string[];
  IsAll: boolean;
  Promotions: Array<Promotion>;
  IsActive: boolean;
}
export default defineComponent({
  components: {
    PromotionCard,
    ElIcon,
    Loading,
  },
  setup() {
    const { getAssetImage } = commonHelper;
    const {
      promotions,
      isDialogVisible,
      onMoreInformation,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      assignHashText,
      applyRequest,
      onClickSpinNow,
      validateLuckyWheelbutton,
    } = usePromotion();
    const presetConditions = reactive<Record<string, IPromotionLFM1>>({
      AllOffer: {
        Name: "all_offer",
        Promotions: [],
        SearchKey: "",
        IsAll: true,
        AvoidKey: [],
        IsActive: true,
      },
      FirstDeposit: {
        Name: "first_deposit",
        Promotions: [],
        SearchKey: "First Deposit",
        IsAll: false,
        AvoidKey: [],
        IsActive: false,
      },
      Common: {
        Name: "common",
        Promotions: [],
        SearchKey: "",
        AvoidKey: ["First Deposit", "Rebate On"],
        IsAll: false,
        IsActive: false,
      },
      RebateOffer: {
        Name: "rebate_offer",
        Promotions: [],
        SearchKey: "Rebate On",
        AvoidKey: [],
        IsActive: false,
        IsAll: false,
      },
    });

    const initPromotions = computed(() => {
      const finalPromotions: Record<string, IPromotionLFM1> = presetConditions;
      if (promotions.value.length < 1) {
        return finalPromotions;
      }
      Object.entries(finalPromotions).forEach(([key, value]) => {
        if (value.IsAll) {
          finalPromotions[key].Promotions = promotions.value.map(
            (p) => new Promotion(p)
          );
          return;
        }
        let tempPromotions = promotions.value.filter((p) =>
          p.PromotionType.includes(value.SearchKey)
        );

        if (value.AvoidKey.length > 0) {
          value.AvoidKey.forEach((k) => {
            tempPromotions = tempPromotions.filter(
              (p) => !p.PromotionType.includes(k)
            );
          });
        }
        finalPromotions[key].Promotions = tempPromotions.map(
          (p) => new Promotion(p)
        );
      });
      return finalPromotions;
    });
    const selectedPromotions = computed(() =>
      Object.values(initPromotions.value).filter(
        (pfd: IPromotionLFM1) => pfd.IsActive
      )
    );
    const onTabClick = (key: string) => {
      Object.keys(presetConditions).forEach((item) => {
        presetConditions[item].IsActive = false;
      });
      presetConditions[key].IsActive = true;
    };
    const route = useRoute();
    watch(
      () => [route.params, promotions.value],
      () => {
        const foundPromotion = promotions.value.find(
          (item) => Number(route.params.id) === item.Id
        );
        if (foundPromotion) {
          promotionModel.value = foundPromotion;
          isDialogVisible.value = true;
        }
      },
      { deep: true, immediate: true }
    );
    const router = useRouter();
    const onClose = () => {
      isDialogVisible.value = false;
      router.push("/promotion");
    };
    return {
      promotions,
      isDialogVisible,
      onMoreInformation,
      selectedPromotions,
      initPromotions,
      onTabClick,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      assignHashText,
      getAssetImage,
      applyRequest,
      onClickSpinNow,
      validateLuckyWheelbutton,
      onClose,
    };
  },
});
</script>
<style lang="scss">
[layout="peru"]{ 
  .body-container.remove-padding {
    padding: 0;
  }
  .mobile-promo-title {
    @media screen and (min-width: 1024px) {
      display: none;
    }
  }
  .desktop-promo-filter {
    @media screen and (max-width: 1024px) {
      display: none;
    }
  }
}

.peru-promotion-container {
  display: flex;
  flex-direction: column;
  gap: 1rem 1rem;
  max-width: 328px;
  margin: 0 auto;
  @media screen and (min-width:764px) {
    flex-direction: row;
    flex-wrap: wrap;
    max-width: 672px;
  }
  @media screen and (min-width: 1024px) {
    max-width: 100%;
    gap: 0.75rem 0.75rem;
  }
  @media screen and (min-width: 1280px) {
  }
}
.peru-promo-card {
  width: 100%;
  background-color: var(--background5);
  border-radius: 0.5rem;
  overflow: hidden;
  border: 2px solid var(--border);
  display: flex;
  flex-direction: column;
  @media screen and (min-width: 764px) {
    max-width: calc(50% - 0.5rem);
  }
  @media screen and (min-width: 1024px) {
    // max-width: 392px;
    height: 380px;
    border: none;
  }
  @media screen and (min-width: 1280px) {
    max-width: 392px;
  }
  .peru-promo-card__img {
      border-bottom: 1px solid var(--primary);
  }
  &:hover {
    .peru-promo-card__img img {
      @media screen and (min-width: 1024px) {
        transition: all 300ms ease-in-out;
        transform: scale(1.1);
      }
    }
  }
  &__btn {
    width: 100%;
    text-transform: capitalize;
    font-weight: 700;
    font-size: 14px;
    line-height: 16.41px;
    border-radius: 9999px;
    padding: 0.75rem;
    display: flex;
    align-items: center;
    justify-content: center;
    position: relative;
    @media screen and (min-width: 1024px) {
      height: 32px;
      text-transform: uppercase;
    }
    .text-container {
      @media screen and (min-width: 1024px) {
        position: absolute;
        top: 50%;
        transform: translateY(-50%);
      }
    }
    &.plain {
      border: var(--primary) 1px solid;
      color: var(--primary);
    }
    &.bg-primary {
      background-color: var(--primary);
      color: var(--textBtn);
      line-height: 16px;
    }
  }
  &__content {
    height: 100%;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    @media screen and (min-width: 1024px) {
      height: 212px;
    }
  }
  &__subtitle {
    font-size: 0.75rem;
    line-height: 1rem;
    &.duration {
      @media screen and (min-width: 1024px) {
        order: 1;
      }
    }
    &.code {
      @media screen and (min-width: 1024px) {
        order: 3;
      }
    }
  }
  &__text {
    @media screen and (min-width: 1024px) {
      font-weight: 700;
      display: flex;
      flex-direction: column;
      gap: 0.5rem 0.5rem;
      margin-bottom: auto;
    }
  }
  &__duration {    
    @media screen and (min-width: 1024px) {
      font-size: 1rem;
    }
  }
  &__code {
    @media screen and (min-width: 1024px) {
      font-size: 0.875rem;
    }
  }
  &__title {
    @media screen and (min-width: 1024px) {
      font-size: 1.25rem;
      order: 2;
      color: var(--text5);
    }
  }
  &__label {
    @media screen and (min-width: 1024px) {
      display: none;
    }
  }
}
.peru-promo-card__img {
  position: relative;
  height: 146px;
  width: 100%;
  overflow: hidden;
  @media screen and (min-width: 1024px) {
    height: 168px;
  }
}
.green-peru-filter {
  filter: invert(56%) sepia(57%) saturate(1449%) hue-rotate(54deg) brightness(106%) contrast(101%);
}

.peru-promotion-dialog {
  background-color: var(--background5);
  border-radius: 0.5rem;
  overflow: hidden;
  max-width: 800px;
  max-height: 714px;
  .el-dialog__header {
    margin-right: 0;
    padding: 0.5rem 1rem;
    background-color: rgba($color: #000000, $alpha: 0.1);
    @media screen and (min-width: 1024px) {
      background-color: var(--primary);
      padding: 1rem 1rem;
    }
  }
  .el-dialog__body {
    background-color: rgba($color: #000000, $alpha: 0.1);
  }
  &__body {
    @media screen and (min-width: 1024px) {
      padding: 2.5rem;
    }
  }
  &__header {
    display: flex;
    justify-content: space-between;
    align-items: center;
    position: relative;
    @media screen and (min-width: 1024px) {
      justify-content: center;
    }
  }
  &__title {
    @media screen and (min-width: 1024px) {
      font-style: normal;
      font-weight: 700;
      font-size: 1.25rem;
      text-align: center;
      letter-spacing: 0.02em;
      color: var(--textBtn);
    }
  }
  &__description {
    padding-right: 0.5rem;
  }
  &__btn-container {
    display: flex;
    justify-content: center;
    align-items: center;
    @media screen and (min-width: 1024px) {
      position: absolute;
      top: 50%;
      right: 0;
      transform: translateY(-50%);
    }
  }
  &__close-btn {
    width: 20px;
    height: 20px;
    position: relative;
    
    @media screen and (min-width: 1024px) {
      transform: rotate(45deg);
    }
    .close-btn {
      @media screen and (min-width: 1024px) {
        display: none;
      }
    }

    &::after, &::before {
      content: '';
      position: absolute;
      width: 20px;
      height: 2px;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
      background-color: var(--textBtn);
      border-radius: 1px;
      @media screen and (max-width: 1024px) {
        display: none;
      }
    }
    &::after {
      transform: translate(-50%, -50%) rotate(90deg);
    }
    .close-btn-text {
      display: none;
    }
  }
  .el-dialog__body {
    padding: 0;
  }
  &__action-container {
    @media screen and (min-width: 1024px) {
      margin-top: 2.5rem;
      display: flex;
      gap: 1rem;
      width: 100%;
      justify-content: center;;
    }
    .peru-promo-card__btn {
      @media screen and (min-width: 1024px) {
        height: 40px;
        text-transform: uppercase;
        min-width: 160px;
        width: fit-content;
      }
      &.close-btn {
        @media screen and (max-width: 1024px) {
          display: none ;
        }
      }
    }
  }
  &__content {
    width: 100%;
    text-align: left;
    padding: 1rem;
    @media screen and (min-width: 1024px) {
      padding: 0;
    }

    .peru-promotion-dialog__info {
      @media screen and (min-width: 1024px) {
        display: none;
      }
    }
  }
  &__info {
    margin-bottom: 8px;
  }
  &__description-container .el-scrollbar__wrap {
    height: fit-content;
    max-height: 35vh;
  }
  &__info-container {
    position: relative;
    width: 100%;
    @media screen and (min-width: 1024px) {
      display: flex;
      gap: 1rem 1rem;
      padding-bottom: 1rem;
      margin-bottom: 1rem;
    }
    .peru-promo-card__img {
      @media screen and (min-width: 1024px) {
        width: 54.44%;
      }
      & img {
        @media screen and (min-width: 1024px) {
          border-radius: 8px;
        }
      }
    }
    .peru-promotion-dialog__info {
      @media screen and (min-width: 1024px) {
        width: 45.56%;
      }
      @media screen and (max-width: 1024px) {
        display: none;
      }
    }
    &::after {
      content: '';
      position: absolute;
      bottom: 0;
      left: 0;
      width: 100%;
      height: 2px;
      background-color: var(--primary);
    }
  }
}
</style>
<style scoped lang="scss">
.tab_title {
  font-size: 14px;
}
.tab {
  display: flex;
  background: var(--background1);
  overflow: auto;
  margin-bottom: 15px;
  font-weight: 700;
  & > * {
    color: var(--text);
    cursor: pointer;
    font-size: 14px;
    white-space: nowrap;
    @apply py-3 pl-3;
  }

  & .active {
    color: #c51e2fed;
  }
}

  @media screen and (max-width: 640px) {
    .peru-promo-card__title {
      color: var(--text2);
    }
    .peru-promo-card__subtitle{
      color: var(--text);
    }
    .peru-promo-card__code{
      color: var(--text2);
    }
}
@media screen and (min-width: 641px) {

    .peru-promo-card__code{
      color: var(--text5);
    }
    
}
</style>
